#include "C_Vector.h"

double C_Vector_Main(double* Column_1,  double* Column_2, double* Column_C1_C2, long Nsize)
{

	// Set the Vectors to size [100];  it may be necessary to change the size 

	double Col_1[100];
	double Col_2[100];
	double Col_C1_C2[100];

	ConvertVBA_Vector_to_C_Vector(Column_1, Col_1, Nsize);
	ConvertVBA_Vector_to_C_Vector(Column_2, Col_2, Nsize);

	Calculate_Vector_Sum (Col_1,  Col_2, Col_C1_C2, Nsize);
	ConvertC_Vector_to_VBA_Vector(Col_C1_C2, Column_C1_C2, Nsize);
	
	double Vector_Average = Calculate_Vector_Average (Col_C1_C2,  Nsize);

	return Vector_Average;
}


void ConvertVBA_Vector_to_C_Vector(double* Col_By_P, double Col_By_V[100], long Nsize)
{
	
	int i;
	for(i =0; i<Nsize; ++i)
	{
			Col_By_V[i] = *(Col_By_P+i);
			
	}
	
	return;	
}

void ConvertC_Vector_to_VBA_Vector(double Col_By_V[100], double* Col_By_P, long Nsize)
{
	
	int i;
	for(i =0; i<Nsize; ++i)
	{
			*(Col_By_P+i) = Col_By_V[i];
			
	}
		return;	
}


void  Calculate_Vector_Sum (double Col_1[], double Col_2[], double Col_C1_C2[], long Nsize)
{
	int i;
	for(i =0; i<Nsize; ++i)
	{
		Col_C1_C2[i] = Col_1[i] + Col_2[i];
	}
	return;
}	

double  Calculate_Vector_Average (double Column[], long Nsize)
{
	int i;
	double Sum =0;
	for(i =0; i<Nsize; ++i)
	{
		Sum = Sum +Column[i];
	}

	return Sum/Nsize;
}
