#include <stdio.h>
#include <math.h>

void GJ_Elimination(double A[3][4], long row);

main()
{
//	double A[3][4] = {{3, -0.1, -0.2, 7.85},{0.1, 7, -0.3, -19.3}, {0.3, -0.2, 10, 71.4}};
//	double A[3][4] = {{2, -2, 5, 13},{2, 3, 4, 20}, {3, -1, 3, 10}};

	double A[3][4] = {{0, 2 ,0, 13},{3, 0, 0, 20}, {0, 0, 3, 10}};
	
	long row =3;
	long col = row+1;

	GJ_Elimination(A, 3);

	printf("Solution is \n");
	for (int i3 =0; i3< row; ++i3)
	{
		for(int j3 =0; j3<col; ++j3)
			printf("%8.3f\t", A[i3][j3]);
		printf("\n");
	}
	return 0;
}

void GJ_Elimination(double A[3][4], long row)
{
	long col = row+1;
	int nonZerIdx = 0;
	

	for(int i =0; i<row; ++i)
	{
		if(A[i][i] == 0.0)
		{
			for (int i2 = i+1; i2<row; ++i2)
			if(A[i2][i] != 0) 
			{
				nonZerIdx = i2;
				break;
			}
			for(int j1 =0; j1<col; ++j1)
			{
				double tmp =  A[i][j1];
				A[i][j1] = A[nonZerIdx][j1];
				A[nonZerIdx][j1] =tmp; 
			}
		}

		double tmpAii = A[i][i];
		for(int j =0; j<col; ++j)
			A[i][j] = A[i][j]/tmpAii;
		
		
		

		for(int i1 =0; i1<row; ++i1)
		{
			if(i1 != i)	
			{
				double tmpAi1 = A[i1][i];
				for(int j =0; j<col; ++j)
					A[i1][j] = A[i1][j] - tmpAi1*A[i][j];
			}
		}
	}
}