/* Future Value of Monthly Annuity Payments*/

# include <stdio.h> 
#include <math.h>

void Annuity_Payout(double, int, double, double[], double[]);
 
main ()
{
int	i_counter;
double Payment = 202.17;
double Interest_Rate = 0.01;
int Period = 20*12;

double Future_Value_Interest[1000];
double Future_Value_Annuity_Payout[1000];

Annuity_Payout(Interest_Rate, Period, Payment, Future_Value_Interest,
							Future_Value_Annuity_Payout);

printf("Month		End of Month	    Interest Earned       Total \n");
printf("     		Payment		    for the month	   Payment \n");

	for (i_counter = 1; i_counter <=Period; i_counter++)
	{
	printf ("  %3d        %6.2f      %6.2f         %8.2f\n", 
				        i_counter, Payment, Future_Value_Interest[i_counter] ,
						Future_Value_Annuity_Payout[i_counter]);
	}

return 0;
}



void Annuity_Payout(double I_R, int Per, double Pay, double FVI[1000], double  FVAP[1000])
{
   int i;
	
   FVAP[0] = 0.;  
   for (i = 1; i <=Per; i++) 
   {
		FVI[i]  = FVAP[i-1]*I_R;	
	    FVAP[i] = FVAP[i-1] + Pay + FVI[i];	
   }
  
}
