# include <stdio.h> 
#include <math.h>

double F_V_A (double, double,  int);
void A_Payout(double, double, int, double[]);
 
main ()
{
double Payment = 202.17;
double Interest_Rate = 0.01;
int Period = 20*12;

double FVA = F_V_A(Payment, Interest_Rate, Period);

printf ("Future Value of the Annuity = %6.2lf\n\n", FVA);

double FVAA[1000];
A_Payout(Payment, Interest_Rate, Period, FVAA);

int i=0;
printf("Month		Deposit    Interest      Total \n");
for(;i<Period; )
{
i = i+1;
printf ("  %3d        %6.2f      %5.2f         %8.2f\n", 
				        i, Payment, FVAA[i]-FVAA[i-1]-Payment, FVAA[i]);
}
return 0;
}


double F_V_A (double Pay, double I_R, int Per)
{
  return Pay*(pow((1+I_R),Per)-1)/(I_R);
}


void A_Payout(double Pay, double I_R, int Per, double  APay[1000])
{
   int i=0;
   APay[i] = 0;  
   for (;i<Per;)
   {
	 i = i+1;
	 APay[i] = Pay+APay[i-1]*(1+I_R);
   }
  
}





