#include "CP.h"

main()
{
 
	printf("%6.2f\n", H_L_Water(21+T0));
	printf("%6.2f\n", H_V_Water(21+T0));
	printf("%6.2f\n", H_L_Ethanol(21+T0));
	printf("%6.2f\n", H_V_Ethanol(21+T0));

	return 0;
}

double H_L_Water(double T1)
{
	return PureEnthalpy(T1, T0, WATER_L);
}

double H_V_Water(double T1)
{
	return PureEnthalpy(T1, T0, WATER_V);
}

double H_L_Ethanol(double T1)
{
	return PureEnthalpy(T1, T0, ETHANOL_L);
}

double H_V_Ethanol(double T1)
{
	return PureEnthalpy(T1, T0, ETHANOL_V);
}


double PureEnthalpy(double T1, const double TRef, const double A[])
{

	return  A[0]*(T1 - TRef) + A[1]/2*(pow(T1, 2) -  pow(TRef, 2)) +
						A[2]/3*(pow(T1, 3) -  pow(TRef, 3));
}




