/* Annuity Coding Example */

# include <stdio.h> 
#include <math.h>

double Annuity_Amount (double, double,  int);
 
main ()
{
double Future_Value = 500000.;
double Interest_Rate = 0.10/12;
int Period = 20*12;

double A_A = Annuity_Amount (Future_Value, Interest_Rate, Period);

printf ("Monthly Payment or Annuity Amount = %7.3lf\n", A_A);

return 0;
}



double Annuity_Amount (double F_V, double I_R, int Per)
{
  return F_V*I_R/(pow((1+I_R),Per)-1);
}


